﻿BrokerControl = LibStub("AceAddon-3.0"):NewAddon("Broker_Control", "AceEvent-3.0", "AceTimer-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")
local LGT = LibStub("LibGroupTalents-1.0")

local mod = BrokerControl

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "enUS", true)
	
if L then
	L["|c000070ddClick:|r |c0000FF00Readycheck.|r\n|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r\n|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r\n|c000070ddCtrl-Click:|r |c0000FF00Role Check.|r"] = true
	L["|c00ff0000Not Promoted|r"] = true
	L["Add Target"] = true
	L["Allow group control for applying saved raid layouts"] = true
	L["Clear Targets"] = true
	L["Click to toggle target as blizzard tank."] = true
	L["Dev Mode"] = true
	L["Free for all"] = true
	L["Friendly Icons"] = true
	L["Group Control"] = true
	L["Group Difficulty"] = true
	L["Group Loot"] = true
	L["HighestPriority"] = true
	L["Hostile Icons"] = true
	L["Icon check delay"] = true
	L["Icon Priorities"] = true
	L["Loot Mode"] = true
	L["Loot Threshold"] = true
	L["LowestPriority"] = true
	L["Main Tanks"] = true
	L["Master Loot"] = true
	L["Max tooltip height"] = true
	L["Maximum height of tooltip before a scrollframe is used. 0 for no scrollframe."] = true
	L["Options"] = true
	L["Please enter layout name"] = true
	L["Raid Difficulty"] = true
	L["Save Layout"] = true
	L["Show Blizzard tanks"] = true
	L["Show tank tooltip"] = true
	L["Show text"] = true
	L["Time between icon reapplication."] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "koKR")
	
if L then
	L["Add Target"] = "대상 추가"
L["Clear Targets"] = "대상 지우기"
L["Free for all"] = "자유 획득"
L["Group Difficulty"] = "던전 난이도"
L["Group Loot"] = "주사위 굴림"
L["Loot Mode"] = "아이템 획득 방식"
L["Loot Threshold"] = "전리품 분배 조건"
L["Master Loot"] = "담당자 획득"
L["Max tooltip height"] = "최대 툴팁 높이"
L["Raid Difficulty"] = "공격대 난이도"
L["Show text"] = "텍스트 보기"
L["|c00ff0000Not Promoted|r"] = "|c00ff0000승급 안됨|r"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "deDE")
	
if L then
	L["Add Target"] = "Ziel hinzufügen"
L["Clear Targets"] = "Ziele löschen"
L["Click to toggle target as blizzard tank."] = "Klicke damit wird das Ziel zum  Blizzardtank umgeschaltet"
L["Free for all"] = "Frei für alle"
L["Group Difficulty"] = "Schwierigkeitsgrad der Gruppe"
L["Group Loot"] = "Plündern als gruppe"
L["HighestPriority"] = "Höchste Priorität"
L["Hostile Icons"] = "Feindliches icon"
L["Icon Priorities"] = "Icon Einstellungen"
L["Icon check delay"] = "Icon check verzögerung"
L["Loot Mode"] = "Plünderungs Modus"
L["Loot Threshold"] = "Blünderungs schwelle"
L["LowestPriority"] = "Nidrigste Priorität"
L["Main Tanks"] = "Haupt tank"
L["Max tooltip height"] = "Maximun Tooltip Höhe"
L["Maximum height of tooltip before a scrollframe is used. 0 for no scrollframe."] = "Maximun höhe des Tooltip, bevor das Scrollframe einschreitet.  0 für kein Scrollframe"
L["Options"] = "Einstellungen"
L["Raid Difficulty"] = "Schwierigkeitgrad des Raids"
L["Show Blizzard tanks"] = "Blizzard tanks anzeigen"
L["Show tank tooltip"] = "Tank Tooltip anzeigen"
L["Show text"] = "Text zeigen"
L[ [=[|c000070ddClick:|r |c0000FF00Readycheck.|r
|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r
|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r
|c000070ddCtrl-Click:|r |c0000FF00Role Check.|r]=] ] = [=[|c000070ddClick:|r |c0000FF00BereitschaftsCheck.|r
|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r
c000070ddShift-Click:|r |c0000FF00In raid umwandeln.|r
|c000070ddCtrl-Click:|r |c0000FF00RollenCheck.|r]=]

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "esES")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "frFR")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "esMX")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "ruRU")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "zhCN")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Control", "zhTW")
	
if L then
	L["Add Target"] = "新增目標"
L["Clear Targets"] = "清除全部目標"
L["Free for all"] = "自由拾取" -- Needs review
L["Friendly Icons"] = "友好目標圖示"
L["Group Loot"] = "隊伍分配"
L["Hostile Icons"] = "敵對目標圖示"
L["Loot Mode"] = "拾取方式"
L["Main Tanks"] = "主坦克"
L["Master Loot"] = "隊長分配"
L["Options"] = "選項"
L["Show tank tooltip"] = "顯示坦克提示資訊"
L[ [=[|c000070ddClick:|r |c0000FF00Readycheck.|r
|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r
|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r
|c000070ddCtrl-Click:|r |c0000FF00Role Check.|r]=] ] = [=[|c000070dd點擊:|r |c0000FF00準備確認。|r
|c000070ddAlt點擊:|r |c0000FF00設置圖示。|r
|c000070ddShift-點擊:|r |c0000FF00轉換為團隊。|r
|c000070ddCtrl-點擊:|r |c0000FF00角色確認。|r]=]

end

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_Control")

local _G = _G
local actualmethod = {"master", "group", "freeforall"}
local checkBox = "|TInterface\\Buttons\\UI-CheckBox-Check:12|t"
local ClassTable = {}
local db
local InstanceDiff
local format = string.format
local ISPROMOTED
local ora2tanks = {}
local LootColors = {"|c001eff00", "|c000080ff", "|c00b048f8"}
local LootThreshold = {_G["ITEM_QUALITY2_DESC"], _G["ITEM_QUALITY3_DESC"], _G["ITEM_QUALITY4_DESC"]}
local LootTypeColors = {"|c00b048f8", "|c000080ff", "|c00ffffff"}
local LootTypes = {L["Master Loot"], L["Group Loot"], L["Free for all"]}
local PartySetText = {_G["DUNGEON_DIFFICULTY1"], _G["DUNGEON_DIFFICULTY2"]}
local PartyText = {"5N", "5H"}
local Player = UnitName("player")
local RaidIconFormat = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_%s:12:12|t"
local RaidSetText = {_G["RAID_DIFFICULTY1"], _G["RAID_DIFFICULTY2"], _G["RAID_DIFFICULTY3"], _G["RAID_DIFFICULTY4"]}
local RaidText = {"10N", "25N", "10H", "25H"}
local TIMERNEEDED
local tinsert = table.insert
local tremove = table.remove
local UIMinus = "|TInterface\\Buttons\\UI-MinusButton-Up:15:15:1:0|t"
local UIPlus = "|TInterface\\Buttons\\UI-PlusButton-Up:15:15:1:0|t"
local IconPriorityText = {			
		L["HighestPriority"],
		"---------",
		"-----",
		"-",
		"-",
		"-----",
		"---------",
		L["LowestPriority"]
}
local Q = {{},{},{},{},{},{},{},{}}
local moved = {}
local roles = {}
local members = {}
local classes = {}
local index = {}
local origgroup = {}
local namedmembers = {}

StaticPopupDialogs["ControlGroupName"] = {
	text = TEXT(L["Please enter layout name"]),
	button1 = TEXT(OKAY),
	OnShow = function (self, data)
	    self.button1:Disable()
	end,
	OnAccept = function (self, data, data2)
	    local text = self.editBox:GetText()
	    mod:SaveGroupLayout(text)
	end,
	EditBoxOnTextChanged = function (self, data)
		self:GetParent().button1:Enable()
	end,
	EditBoxOnEnterPressed = function (self)
		StaticPopup_Hide("ControlGroupName")
		local text = self:GetText()
	   	mod:SaveGroupLayout(text)
	end,
	hasEditBox = true,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1,
}

local defaults = {
	profile = {
		devmode = nil,
		expandtanks = true,
		showtext = true,
		showdiff = true,
		showgroup = true,
		showgroupcontrol = true,
		showthresh = true,
		showtype = true,
		showprio = true,
		showfriendly = true,
		showhostile = true,
		showora2tanks = nil,
		showtanktt = true,
		iconpriority = {[1] = 8, [2] = 7, [3] = 2, [4] = 1, [5] = 3, [6] = 4, [7] = 5, [8] = 6},
		friendlytargets = {},
		hostiletargets = {},
		grouplayouts = {},
		maxheight = 0,
		timedelay = 10,
		x = 0,
		y = 0,
		point = "CENTER",
		relpoint = "CENTER",
	}
}

local options = {
	name = "Broker Control",
	handler = mod,
	type = "group",
	args = { 
		options = {
			name = L["Options"],
			handler = mod,
			type = "group",
			args = {
				dev = {
					type = "toggle",
					name = L["Dev Mode"],
					get = function() return mod.db.profile.devmode end,
					set = function(info, v) mod.db.profile.devmode = v end,
					order = 5
					},
				stext = {
					type = "toggle",
					name = L["Show text"],
					get = function() return mod.db.profile.showtext end,
					set = function(info, v) mod.db.profile.showtext = v mod:UpdateBrokerText() end,
					order = 10
				},
				tanks = {
					type = "toggle",
					name = L["Main Tanks"],
					desc = L["Show Blizzard tanks"],
					get = function() return mod.db.profile.showora2tanks end,
					set = function(info, v) mod.db.profile.showora2tanks = v end,
					order = 12
				},
				tanktt = {
					type = "toggle",
					name = L["Show tank tooltip"],
					get = function() return mod.db.profile.showtanktt end,
					set = function(info, v) mod.db.profile.showtanktt = v end,
					order = 13
				},
				gcontrol = {
					type = "toggle",
					name = L["Group Control"],
					desc = L["Allow group control for applying saved raid layouts"],
					get = function() return mod.db.profile.showgroupcontrol end,
					set = function(info, v) mod.db.profile.showgroupcontrol = v end,
					order = 14
				},
				height = {
					type = "range",
					name = L["Max tooltip height"],
					desc = L["Maximum height of tooltip before a scrollframe is used. 0 for no scrollframe."],
					get = function() return mod.db.profile.maxheight end,
					set = 	function(info, v) mod.db.profile.maxheight = v mod:UpdateBrokerText() end,
					min = 0, 
					max = 1500, 
					step = 25,
					order = 15
				},
				delay = {
					type = "range",
					name = L["Icon check delay"],
					desc = L["Time between icon reapplication."],
					get = function() return mod.db.profile.timedelay end,
					set = 	function(info, v) mod.db.profile.timedelay = v end,
					min = 1, 
					max = 60, 
					step = 1,
					order = 20
				},
			}
		}
	}
}
		

function mod:OnInitialize()
	if AddonLoader and AddonLoader.RemoveInterfaceOptions then
    		AddonLoader:RemoveInterfaceOptions("Broker_Control")
	end
	self.db = LibStub("AceDB-3.0"):New("BrokerControlDB", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_Control", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Control", "Broker_Control")
	self:CreateLDBObject()
end

function mod:OnEnable()
	db = mod.db.profile
		
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	self.button = nil
	self.Classcolors = {}
	self:SetupClasses()
	self:CheckTimer()
end

function mod:OnDisable()
	self:CancelAllTimers() 
end

function mod:OnProfileChanged()
	db = self.db.profile
end

function mod:debug(message)
	if db.devmode then
		DEFAULT_CHAT_FRAME:AddMessage(message)
	end
end

function mod:SetupClasses()
	for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
		mod.Classcolors[class] = mod:GetClassHexColour(class)
	end
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(function()
        		for class, color in pairs(CUSTOM_CLASS_COLORS) do
               			mod.Classcolors[class] = mod:GetClassHexColour(class)
          		end
        	end)
	end
end

function mod:GetClassHexColour(class)
	if (CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", CUSTOM_CLASS_COLORS[class].r*255, CUSTOM_CLASS_COLORS[class].g*255, CUSTOM_CLASS_COLORS[class].b*255)
	elseif (RAID_CLASS_COLORS and RAID_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
	else
		return "a1a1a1"
	end
end

function mod:CheckTimer()
	if self:TimerNeeded(db.friendlytargets) or self:TimerNeeded(db.hostiletargets) then
		self:debug("Need timer")
		TIMERNEEDED = true
	else TIMERNEEDED = nil
	end
end

function mod:TimerNeeded(table)
	for i = 1,8 do
		if table[i] then return true end
	end
	return false
end

function mod:PLAYER_REGEN_DISABLED()
	if TIMERNEEDED and ISPROMOTED and not self.combattimer then 
		self.combattimer = self:ScheduleRepeatingTimer("CheckIcons", db.timedelay)
		self:debug("Started timer")
		self:CheckIcons()
	end
end

function mod:PLAYER_REGEN_ENABLED()
	if TIMERNEEDED and self.combattimer then 
		self:CancelTimer(self.combattimer, true)
		self.combattimer = nil
		self:debug("Stopped timer")
	end
end

function mod:RAID_ROSTER_UPDATE()
	InstanceDiff = self:GetDifficulty()
	self:UpdateBrokerText()
	if db.showora2tanks then
		mod:UpdateTanks()
	end
end

function mod:PARTY_LOOT_METHOD_CHANGED()
	if self.tooltip then self.tooltip:Clear() end
	InstanceDiff = self:GetDifficulty()
	self:DisplayTooltip()
end

function mod:PARTY_MEMBERS_CHANGED()
	if TIMERNEEDED then
		if self:IsPromoted() or self:IsLeader() or not self:InRaid() then ISPROMOTED = true
		else ISPROMOTED = nil end
	end
	InstanceDiff = self:GetDifficulty()
	if db.showora2tanks then
		mod:UpdateTanks()
	end
	self:UpdateBrokerText()
end

function mod:PLAYER_ENTERING_WORLD()
	self:PARTY_MEMBERS_CHANGED()
end

function mod:GetDifficulty()
	local _, _, difficultyIndex, _, maxPlayers, dynamicHeroic, isDynamic = GetInstanceInfo()
	--self:debug("index="..difficultyIndex.."max="..maxPlayers..((dynamicHeroic or "NIL"))..(((isDynamic  and "TRUE") or "NIL")))
	if maxPlayers == 0 then return (self:InRaid() and GetRaidDifficulty()) or GetDungeonDifficulty()
	elseif maxPlayers == 5 then return GetDungeonDifficulty()
	else
		if isDynamic and dynamicHeroic == 1 and difficultyIndex <= 2 then difficultyIndex = difficultyIndex + 2 end
		--self:debug("Difficulty="..difficultyIndex)
		return difficultyIndex
	end
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Broker_Control", {type = "data source", icon = "Interface\\Icons\\Ability_Rogue_FindWeakness.png"})
	mod.obj.OnClick = function(frame, button)
		if button == "RightButton" then
			if not C.OpenFrames["Broker_Control"] then C:Open("Broker_Control") 
			else C:Close("Broker_Control") end
		else 
			if IsShiftKeyDown() then ConvertToRaid()
			elseif IsAltKeyDown() then mod:CheckIcons()
			elseif IsControlKeyDown() then InitiateRolePoll()
			else DoReadyCheck() end
		end
	end
	mod.obj.OnEnter = function(frame)
			if mod.tooltip then mod:HideTooltip() end
			local tooltip = QTC:Acquire("Broker_ControlTooltip", 2, "LEFT", "LEFT")
			tooltip:Clear()
			tooltip:SmartAnchorTo(frame)
			tooltip:SetScript("OnLeave", mod.HideTooltip)
			tooltip:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
			mod.tooltip = tooltip
			mod:DisplayTooltip()
		end
	mod.obj.OnLeave = function()
		mod:HideTooltip()
	end
end

function mod:HideTooltip(force)
	if self.tooltip then
		if MouseIsOver(self.tooltip) and not force then return end
		self.tooltip:SetScript("OnLeave", nil)
		self.tooltip:SetScript("OnUpdate", nil)
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	if db.showtext then
		local threshold = GetLootThreshold()
		local text
		if self:InRaid() then 
			text = LootColors[threshold - 1] .. (RaidText[InstanceDiff] or "?") .. "|r"
		elseif self:InParty() then 
			text = LootColors[threshold - 1] .. (PartyText[InstanceDiff] or "?") .. "|r"
		else text = ""
		end
		mod.obj.text = text
	else mod.obj.text = ""
	end
end

function mod:InParty()
	if GetNumPartyMembers() > 0 then return true end
	return false
end

function mod:InRaid()
	return UnitInRaid("player") 
end

function mod:IsLeader()
	return IsRaidLeader()
end

function mod:IsPromoted()
	return IsRaidOfficer() 
end

function mod:IsPartyLeader()
	return IsPartyLeader()
end

function mod:UnitInGroup(unit)
	return UnitInParty(unit) or UnitInRaid(unit)
end

function mod:DisplayTooltip()
	local tooltip = mod.tooltip
	if not tooltip then self:UpdateBrokerText() return end
	
	InstanceDiff = self:GetDifficulty()
	local threshold = GetLootThreshold()
	local lootmethod = GetLootMethod()
	
	if db.showora2tanks and (self:IsPromoted() or self:IsLeader() or self:IsPartyLeader()) then
		if not self.button then self.button = self:GetButton() end
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.expandtanks then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Main Tanks"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtanks"})
			for tank = 1, 6 do
				local y, x = tooltip:AddLine()
				local text = "------------------"
				if ora2tanks[tank] then text = self:FormatName(ora2tanks[tank]) end
				tooltip:SetCell(y, 1, tank, nil, "RIGHT")
				tooltip:SetCell(y, 2, text, nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Main Tanks"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtanks"})
		end
	end
	if db.showgroupcontrol and self:InRaid() and (self:IsPromoted() or self:IsLeader()) then
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showgroup then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Group Control"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showgroup"})
			for index, layout in ipairs(db.grouplayouts) do
				local y, x = tooltip:AddLine()
				tooltip:SetCell(y, 2, layout.name, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"GroupAction", index}) 
			end 
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Save Layout"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"SaveLayout"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Group Control"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showgroup"})
		end
	end
	if self:IsLeader() and self:InRaid() then
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showdiff then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Raid Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
			for id, text in ipairs(RaidSetText) do
				local y, x = tooltip:AddLine()
				if id == InstanceDiff then tooltip:SetCell(y, 1, checkBox, nil, "RIGHT") 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Raid", id}) 
				end
				tooltip:SetCell(y, 2, "|c00FFFFFF" .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Raid Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
		end
		tooltip:AddSeparator()
	elseif self:IsPartyLeader() then
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showdiff then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Group Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
			for id, text in ipairs(PartySetText) do
				local y, x = tooltip:AddLine()
				if id == InstanceDiff then tooltip:SetCell(y, 1, checkBox, nil, "RIGHT") 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Party", id}) 
				end
				tooltip:SetCell(y, 2, "|c00FFFFFF" .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Group Difficulty"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showdiff"})
		end
		tooltip:AddSeparator()
	end
	if self:IsLeader() or self:IsPartyLeader() then
		local y, x = tooltip:AddLine()
		if db.showthresh then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Loot Threshold"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showthresh"})
			for id, text in ipairs(LootThreshold) do
				local y, x = tooltip:AddLine()
				if id == threshold - 1 then tooltip:SetCell(y, 1, checkBox, nil, "RIGHT") 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Loot", id + 1}) 
				end
				tooltip:SetCell(y, 2, LootColors[id] .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Loot Threshold"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showthresh"})
			
		end
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showtype then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Loot Mode"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtype"})
			for id, text in ipairs(LootTypes) do
				local y, x = tooltip:AddLine()
				if actualmethod[id] == lootmethod then tooltip:SetCell(y, 1, checkBox, nil, "RIGHT") 
				else tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"Type", id}) 
				end
				tooltip:SetCell(y, 2, LootTypeColors[id] .. text .. "|r", nil, "LEFT")
			end
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Loot Mode"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showtype"})
			
		end
		tooltip:AddSeparator()
	end
	local y, x = tooltip:AddLine()
	if db.showprio then
		tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Icon Priorities"] .. "|r", nil, "LEFT", 2)
		tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showprio"})
		for icon = 1,8 do
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 1, format(RaidIconFormat, db.iconpriority[icon]), nil, "RIGHT")
			tooltip:SetCell(y, 2, IconPriorityText[icon], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconPrio", icon}) 
		end
	else
		tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Icon Priorities"] .. "|r", nil, "LEFT", 2)
		tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showprio"})
	end
	if self:IsPromoted() or self:IsLeader() or (not self:InRaid() and self:InParty()) then
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showfriendly then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Friendly Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showfriendly"})
			for icon = 1,8 do
				local y, x = tooltip:AddLine()
				local text = self:FormatName(db.friendlytargets[icon])
        			tooltip:SetCell(y, 1, format(RaidIconFormat, icon), nil, "RIGHT")
				tooltip:SetCell(y, 2, text, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconFriendly", icon}) 
			end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Clear Targets"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"ClearFriendly"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Friendly Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showfriendly"})
		end
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		if db.showhostile then
			tooltip:SetCell(y, x, UIMinus .. "|c0000FF00" .. L["Hostile Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showhostile"})
			for icon = 1,8 do
				local y, x = tooltip:AddLine()
				local text = self:FormatName(db.hostiletargets[icon])
        			tooltip:SetCell(y, 1, format(RaidIconFormat, icon), nil, "RIGHT")
				tooltip:SetCell(y, 2, text, nil, "LEFT")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"IconHostile", icon}) 
			end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, 2, L["Clear Targets"], nil, "LEFT")
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"ClearHostile"}) 
		else
			tooltip:SetCell(y, x, UIPlus .. "|c0000FF00" .. L["Hostile Icons"] .. "|r", nil, "LEFT", 2)
			tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {"showhostile"})
		end
		tooltip:AddSeparator()
		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["|c000070ddClick:|r |c0000FF00Readycheck.|r\n|c000070ddAlt-Click:|r |c0000FF00Set Icons.|r\n|c000070ddShift-Click:|r |c0000FF00Convert to raid.|r\n|c000070ddCtrl-Click:|r |c0000FF00Role Check.|r"], nil, "CENTER", 2)   
	else
      		local y, x = tooltip:AddLine()
		tooltip:SetCell(y, x, L["|c00ff0000Not Promoted|r"], nil, "CENTER", 2)      
       	end
	
	local height = db.maxheight
	if height == 0 then height = nil end 
        tooltip:UpdateScrolling(height)
        
        self:UpdateBrokerText()
	tooltip:Show()
end

function mod:HandleTTClick(data, button)
	if not data then return end
	local command = data[1]
	local id = data[2]
	
	if command == "showdiff" then db.showdiff = not db.showdiff
        elseif command == "showthresh" then db.showthresh = not db.showthresh
        elseif command == "showprio" then db.showprio = not db.showprio
        elseif command == "showtype" then db.showtype = not db.showtype
        elseif command == "showfriendly" then db.showfriendly = not db.showfriendly
        elseif command == "showhostile" then db.showhostile = not db.showhostile
	elseif command == "showtanks" then db.expandtanks = not db.expandtanks
       	elseif command == "showgroup" then db.showgroup = not db.showgroup
        elseif command == "Raid" and id then SetRaidDifficulty(id)
        elseif command == "Party" and id then SetDungeonDifficulty(id)
        elseif command == "Loot" and id then SetLootThreshold(id)
        elseif command == "Type" and id then SetLootMethod(actualmethod[id], Player)
        elseif command == "IconPrio" and id then 
        	local movevalue = db.iconpriority[id]
        	if button == "LeftButton" then		--move prio up
        		tremove(db.iconpriority, id)
        		if id == 1 then id = 9 end
        		tinsert(db.iconpriority, id - 1, movevalue)
        	elseif button == "RightButton" then	--move prio down
        		tremove(db.iconpriority, id)
        		if id == 8 then id = 0 end
        		tinsert(db.iconpriority, id + 1, movevalue)
        	end
        elseif command == "IconFriendly" and id then 
        	if button == "RightButton" then	
        		db.friendlytargets[id] = nil 
        	else
        		if not mod:UnitInGroup("target") or mod:IconAlreadyAssigned(db.hostiletargets, id) then return end
        		local target = UnitName("target")
        		mod:RemoveDuplicateUnit(target, db.friendlytargets)
        		db.friendlytargets[id] = target
        	end
        	mod:CheckTimer()
        elseif command == "IconHostile" and id then 
        	if button == "RightButton" then	
        		db.hostiletargets[id] = nil 
        	else
        		if not mod:UnitInGroup("target") or mod:IconAlreadyAssigned(db.friendlytargets, id) then return end
        		local target = UnitName("target")
        		mod:RemoveDuplicateUnit(target, db.hostiletargets)
        		db.hostiletargets[id] = target	
        	end
        	mod:CheckTimer()
        elseif command == "GroupAction" and id then 
        	if button == "RightButton" then	
        		tremove(db.grouplayouts, id)
        	else
        		mod:RestoreLayout(id)
        	end
        elseif command == "ClearFriendly" then 
        	mod:ClearAllIcons(db.friendlytargets)
        	db.friendlytargets = {}
        	mod:CheckTimer()
        elseif command == "ClearHostile" then 
        	db.hostiletargets = {}
        	mod:CheckTimer()
        elseif command == "SaveLayout" then 
        	StaticPopup_Show("ControlGroupName")
        end
      	InstanceDiff = mod:GetDifficulty()
        mod.tooltip:Clear()
	mod:DisplayTooltip()
end

function mod:GetButton()
	if not db.showtanktt then return end
	local button = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate")
	local db = mod.db.profile
	button:SetWidth(30)
	button:SetHeight(30)
	button:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
	local image = button:CreateTexture(nil, "BACKGROUND")
	button.icon = image
	image:SetAllPoints(button)
	button:SetPoint(db.point, UIParent, db.relpoint, db.x, db.y)
	button.icon:SetTexture("Interface\\Icons\\Ability_Warrior_ShieldReflection")
	button:SetScript("OnEnter", function(f)
		if mod.db.profile.showtanktt then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:AddLine(L["Click to toggle target as blizzard tank."], 0, 1, 0)
			GameTooltip:Show()
		end
	end)
	button:SetScript("OnLeave", function(f) if mod.db.profile.showtanktt then GameTooltip:Hide() end end)
	button:SetMovable(1)
	button:RegisterForDrag("LeftButton")
   	button:SetScript("OnDragStart", function(f) f:StartMoving() end)
   	button:SetScript("OnDragStop", function(f) 
   					f:StopMovingOrSizing() 
   					local p, t, v, x, y = f:GetPoint()
					db.x = math.floor(x)
					db.y = math.floor(y)
					db.point = p
					db.relpoint = v
			end)
	
	button:SetAttribute("type", "maintank")
	button:SetAttribute("action", "toggle")
	button:SetAttribute("unit", "target")
	button:Enable()
	button:Show()
	return button
end

function mod:RemoveDuplicateUnit(unit, table)
	for index, name in pairs(table) do
		if name == unit then 
			table[index] = nil
			return
		end
	end
end

function mod:UpdateTanks(tanks)
	if self:IsPromoted() or self:IsLeader() or self:IsPartyLeader() then
		wipe(ora2tanks)
		local group = "party"
		local members = GetNumPartyMembers()
		local numraid = GetNumRaidMembers()
		if numraid > 0 then 
			members = numraid 
			group = "raid"
		end
		for i = 1, members do
			if GetPartyAssignment("MAINTANK", group..i) then 
				local name = UnitName(group..i)
				tinsert(ora2tanks, name) 
			end
		end
		if mod.tooltip then
			mod.tooltip:Clear()
			mod:DisplayTooltip()
		end
	end
end

function mod:FormatName(name)
	if name then 
		local _, class = UnitClass(name)
		if class then return mod.Classcolors[class] .. name .. "|r" end
        end
        return "--------------------"
end

function mod:IconAlreadyAssigned(table, icon)
	return table[icon]
end

function mod:ClearAllIcons(table)
	for icon = 1,8 do
		if table[icon] then SetRaidTarget(table[icon], 0) end
	end
end

function mod:CheckIcons()
	if self:TimerNeeded(db.friendlytargets) then
		for icon = 1,8 do
			local unit = db.friendlytargets[icon] 
			if unit and UnitIsVisible(unit) then SetRaidTarget(unit, icon) end
		end
	end
	if self:TimerNeeded(db.hostiletargets) then
		for icon = 1,8 do
			local unit = db.hostiletargets[icon] 
			if unit and UnitIsVisible(unit) then
				local target = unit .. "-target"
				local hastarget = UnitName(target)
				if hastarget and not UnitIsFriend(Player, target) then
					local targeticon = GetRaidTargetIndex(target)
					if targeticon then
						if self:GetPriority(icon) < self:GetPriority(targeticon) then
							SetRaidTarget(target, icon)
						end
					else 
						SetRaidTarget(target, icon)
					end
				end
			end
		end
	end
end
		
function mod:GetPriority(icon)
	for i = 1,8 do
		if db.iconpriority[i] == icon then return i end
	end
end

function mod:SaveGroupLayout(layoutname)
	self:debug("Saving.."..layoutname)
	local totalmembers = GetNumRaidMembers()
	local layouttable = {{name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}, {name = {}, class = {}, role = {}}}
	for i = 1, totalmembers do
		local name, _, subgroup, _, class = GetRaidRosterInfo(i)
		local role = LGT:GetUnitRole(name)
		if class == "HUNTER" then role = "ranged" end
		if not role then role = "UNKNOWN" end
		tinsert(layouttable[subgroup].name, name)
		tinsert(layouttable[subgroup].class, class)
		tinsert(layouttable[subgroup].role, role)
	end
	tinsert(db.grouplayouts, {name = layoutname, layout = layouttable})
end

function mod:RestoreLayout(id)
	roles = {}
	members = {}
	classes = {}
	index = {}
	origgroup = {}
	Q = {{},{},{},{},{},{},{},{}}
	moved = {}
	namedmembers = {}
	local layouttable = db.grouplayouts[id].layout
	local totalmembers = GetNumRaidMembers()
	for i = 1, totalmembers do
		local name, _, subgroup, _, class = GetRaidRosterInfo(i)
		local role = LGT:GetUnitRole(name)
		if class == "HUNTER" then role = "ranged" end
		tinsert(members, name)
		tinsert(classes, class)
		tinsert(roles, role)
		tinsert(index, i)
		tinsert(origgroup, subgroup)
		Q[subgroup][name] = i
	end
	for group, layout in ipairs(layouttable) do
		for _, name in pairs(layout.name) do
			namedmembers[name] = true
		end
	end
	for group, layout in ipairs(layouttable) do
		for slot = 1,5 do
			if layout.name[slot] then
				local found = self:FindData(members, layout.name[slot]) 
				if found then self:MoveMember(found, group)
				else
					local wantrole = layout.role[slot]
					local wantclass = layout.class[slot]
					local foundrole = self:FindData(roles, wantrole) 
					local foundclass = self:FindData(classes, wantclass) 
					if foundclass and foundrole and foundclass == foundrole then self:MoveMember(foundrole, group)
					else
						if wantrole ~= "UNKNOWN" and foundrole then
							local match
							self:debug("Search by role for class match")
							for i = foundrole + 1, #roles do
								if roles[i] == wantrole and classes[i] == wantclass and not namedmembers[layout.name[i]] then 
									self:MoveMember(i, group)
									match = true
									break
								end
							end
							if not match then 
								self:debug("No class match for "..wantclass.." "..wantrole)
								if not namedmembers[layout.name[foundrole]] then 
									self:MoveMember(foundrole, group) 
								else
									self:debug("Search for another suitable role match")
									for i = foundrole + 1, #roles do
										if roles[i] == wantrole and not namedmembers[layout.name[i]] then 
											self:MoveMember(i, group)
											break
										end
									end
								end
							end	
						else 
							if foundclass then 
								self:debug("Move class we found no role match")
								if not namedmembers[layout.name[foundclass]] then self:MoveMember(foundclass, group) end
							else		--no role found and no class match!  who do we move? no one
								self:debug("No match found leaving slot empty")
							end
						end
					end
				end
			end
		end
	end
end

function mod:FindData(table, value)
	for key, val in pairs(table) do
		if val == value then return key end
	end
	return 
end

function mod:MoveMember(id, group)
	local name = members[id]
	local memgroup = origgroup[id]
	local gindex = index[id]
	if not name then return end
	if Q[group][name] then 	--already in right group
		self:debug(name.." already in "..group)
		moved[name] = true
		return 
	end	
	self:debug("Trying to move.."..name.." to "..group)
	local found, moveid, mover = self:FindEligibleMove(group)
	if found then				--someone to swap with
		self:debug("Swap user.."..name.." with "..mover.." in "..group)
		SwapRaidSubgroup(gindex, moveid)
		Q[group][name] = gindex
		Q[memgroup][name] = nil
		Q[group][mover] = nil
		Q[memgroup][mover] = moveid
		moved[name] = true
		self:ClearMember(id)
	elseif moveid < 5 then			--empty spots move freely
		self:debug("Moved user.."..name.." from "..memgroup.." to "..group)
		SetRaidSubgroup(gindex, group)
		Q[group][name] = gindex
		Q[memgroup][name] = nil
		moved[name] = true
		self:ClearMember(id)
	else
		self:debug("No move found for "..name.."!!")
	end
end

function mod:FindEligibleMove(group)
	local count = 0
	for mover, id in pairs(Q[group]) do
		count = count + 1
	end
	if count < 5 then return nil, count 
	else
		for mover, id in pairs(Q[group]) do
			if not moved[mover] then return true, id, mover end
		end
	end
	return nil, count
end

function mod:ClearMember(id)
	tremove(members, id)
	tremove(classes, id)
	tremove(roles, id)
	tremove(index, id)
	tremove(origgroup, id)
end